# Python imports
# import rel
import json

# Lib imports
import gi
from gi.repository import GLib

# Application imports
from . import websocket 



class WebsocketClient:
    def __init__(self):
        self.ws = None


    def send(self, message: str):
        self.ws.send(message)

    def set_callback(self, callback: object):
        self.respond = callback

    def on_message(self, ws, message: dict):
        GLib.idle_add(self.respond, message)

    def on_error(self, ws, error: str):
        logger.debug(f"WS Error:  {error}")

    def on_close(self, ws, close_status_code: int, close_msg: str):
        logger.debug("WS Closed...")

    def on_open(self, ws):
        logger.debug("WS opened connection...")

    def close_client(self):
        self.ws.close()

    @daemon_threaded
    def start_client(self):
        # websocket.enableTrace(True)
        self.ws = websocket.WebSocketApp("ws://localhost:4114",
                                  on_open = self.on_open,
                                  on_message = self.on_message,
                                  on_error = self.on_error,
                                  on_close = self.on_close)

        # Set dispatcher to automatic reconnection, 5 second reconnect delay
        # self.ws.run_forever(dispatcher = rel, reconnect = 5)
        # rel.signal(2, rel.abort)  # Keyboard Interrupt
        # rel.dispatch()

        self.ws.run_forever(reconnect = 0.5)
